<template>
	<v-card class="tableCard" flat>
		<v-card-title>
			<v-text-field v-model="search" append-icon="mdi-magnify" label="Search groups..." single-line hide-details />
		</v-card-title>

		<v-data-table
			class="groupsTable"
			:headers="headers"
			:items="tableData"
			:loading="isLoading"
			:search="search"
			:page.sync="page"
			multi-sort
			loading-text="Loading groups..."
			:no-data-text="hasError ? 'There was an error loading groups. Please refresh.' : 'No groups'"
		>
			<template v-slot:item.apiOnly="{ item }">
				<v-simple-checkbox
					v-model="item.apiOnly"
					:indeterminate="item.hideChangeIsLoading"
					@input="(event) => handleHiddenChange(item, event)"
				></v-simple-checkbox>
			</template>
			<template v-slot:item.meta.submittedAt="{ item }">
				{{ new Date(item.meta.submittedAt).toLocaleString() }}
			</template>
			<template slot="item.actions" slot-scope="props">
				<group-delete-button :group="props.item" small />
			</template>
		</v-data-table>
	</v-card>
</template>

<script lang="ts">
import { computed, defineComponent, ref, watch } from '@vue/composition-api';
import { DataTableHeader } from 'vuetify';
import { Group } from '@/store/types';
import GroupDeleteButton from '@/views/super-admin/GroupDeleteButton.vue';
import soilApiService from '../../services/soilApiService';

export default defineComponent({
	components: { GroupDeleteButton },
	props: {
		isLoading: {
			type: Boolean,
		},
		isLoaded: {
			type: Boolean,
		},
		hasError: {
			type: Boolean,
		},
		groups: {
			type: Array as () => Group[],
			default: [],
		},
	},
	setup(props, { root }) {
		const search = ref<string>('');
		const page = ref<number>(1);
		const headers: DataTableHeader[] = [
			{ text: 'ID', value: 'id' },
			{ text: 'Group Name', value: 'name' },
			{ text: 'Path', value: 'path' },
			{ text: 'Hidden', value: 'apiOnly' },
			{ text: 'Subgroups', value: 'children.length' },
			{ text: 'Created', value: 'meta.submittedAt' },
			{ text: '', value: 'actions', sortable: false },
		];

		type TableGroup = Group & { hideChangeIsLoading: boolean };

		const tableData = computed<TableGroup[]>(() =>
			props.groups.map((group) => ({
				...group,
				hideChangeIsLoading: false,
			}))
		);

		watch(search, () => (page.value = 1));

		const handleHiddenChange = (item: TableGroup, event: boolean) => {
			item.hideChangeIsLoading = true;
			soilApiService.editGroup({ groupId: item.id, apiOnly: event }).then(() => {
				root.$store.dispatch('groups/getGroups');
			});
		};

		return {
			search,
			page,
			headers,
			tableData,
			handleHiddenChange,
		};
	},
});
</script>

<style lang="scss">
.groupsTable.v-data-table table > tbody > tr {
	& > td:first-child {
		width: 320px;
	}
	& > td:last-child {
		width: 80px;
	}
}
</style>
